import React from 'react';
import {
  colorPaletteConfigSlice,
  querybuilderSlice,
  setQuerybuilderNodes,
} from '@graphpolaris/shared/lib/data-access/store';
import { GraphPolarisThemeProvider } from '@graphpolaris/shared/lib/data-access/theme';
import { configureStore } from '@reduxjs/toolkit';
import { Meta } from '@storybook/react';
import { Provider } from 'react-redux';
import { MultiGraph } from 'graphology';
import { QueryBuilder } from '../../../panel';
import { QueryGraph } from '../../../model/graphology/model';
import { circular } from 'graphology-layout';
import { QueryMultiGraphology } from '../../../model';

const Component: Meta<typeof QueryBuilder> = {
  component: QueryBuilder,
  title: 'Querybuilder/Pills/relationPill',
  decorators: [
    (story) => (
      <Provider store={mockStore}>
        <GraphPolarisThemeProvider>{story()}</GraphPolarisThemeProvider>
      </Provider>
    ),
  ],
};

// Mock palette store
const mockStore = configureStore({
  reducer: {
    colorPaletteConfig: colorPaletteConfigSlice.reducer,
    querybuilder: querybuilderSlice.reducer,
  },
});
const graph = new QueryMultiGraphology();
graph.addPill2Graphology(
  {
    type: 'relation',
    x: 140,
    y: 140,
    name: 'Relation Pill',
    depth: { min: 0, max: 1 },
    fadeIn: false,
  },
  '2'
);
console.log(graph.export());

mockStore.dispatch(setQuerybuilderNodes(graph.export()));

export const Flow = {
  args: {},
};

export default Component;
