/**
 * This program has been developed by students from the bachelor Computer Science at
 * Utrecht University within the Software Project course.
 * © Copyright Utrecht University (Department of Information and Computing Sciences)
 */
import {
  MinMaxType,
  PlotType,
  RelationType,
  AxisLabel,
  PlotSpecifications,
  EntitiesFromSchema,
} from './Types';
import CalcScaledPosUseCase from './utils/CalcScaledPositionsUseCase';
import FilterUseCase from './utils/FilterUseCase';

import CalcDefaultPlotSpecsUseCase from './utils/CalcDefaultPlotSpecsUseCase';
import ToPlotDataParserUseCase from './utils/ToPlotDataParserUseCase';
import CalcXYMinMaxUseCase from './utils/CalcXYMinMaxUseCase';

import { ClassNameMap } from '@mui/material';
import { NodeLinkResultType, isNodeLinkResult } from '../shared/ResultNodeLinkParserUseCase';
import CalcEntityAttrNamesFromSchemaUseCase from './utils/CalcEntityAttrNamesFromSchemaUseCase';
import CalcEntityAttrNamesFromResultUseCase from './utils/CalcEntityAttrNamesFromResultUseCase';
import { isSchemaResult } from '../shared/SchemaResultType';

/** An implementation of the `SemanticSubstratesViewModel` to be used by the semantic-substrates view. */
export default class SemanticSubstratesViewModel {
  /**
   * These functions are mock function for now, but can be properly implemented later down the line.
   */
  public scaleCalculation: (x: number) => number = (x: number) => {
    return 3;
  };
  public colourCalculation: (x: string) => string = (x: string) => {
    return '#d56a50';
  };
  public relationColourCalculation: (x: string) => string = (x: string) => {
    return '#d49350';
  };
  private relationScaleCalculation: (x: number) => number = (x: number) => {
    return 1;
  };

  /** Initializes the plots and relations arrays as empty arrays. */
  public constructor(state: SemanticSubstratesState, setState) {
    this.state = state;
    this.setState = setState;
  }





  // /**
  //  * Subscribe to the schema result routing key so that this view model is receiving results that are to be visualised.
  //  */
  // public subscribeToSchemaResult(): void {
  //   Broker.instance().subscribe(this, 'schema_result');
  // }

  // /**
  //  * Unsubscribe from the schema result routing key so that this view model no longer handles query results from the backend.
  //  */
  // public unSubscribeFromSchemaResult(): void {
  //   Broker.instance().unSubscribe(this, 'schema_result');
  // }
}
